/*

shieldequalizercapacitors.js

Script for shield equalizer and shield capacitor equipment for your ship.


Oolite
Copyright  2003-2010 Giles C Williams and contributors

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA 02110-1301, USA.


shieldequalizercapacitors.oxp
Copyright  2011 "CommonSenseOTB"

This work is licensed under the Creative Commons
Attribution-Noncommercial-Share Alike 3.0 Unported License.

To view a copy of this license, visit
http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter
to Creative Commons, 171 Second Street, Suite 300, San Francisco,
California, 94105, USA.

*/

this.name               = "shieldequalizercapacitors";
this.author               = "CommonSenseOTB";
this.copyright            = "Copyright 2011 by CommonSenseOTB CC-NC-by-SA 3.0";
this.description         = "Provides shield equalizer and shield capacitor equipment for your ship.";
this.version            = "1.3";


this.startUp = function()
   {
   // You may toggle the sound and messages here
   // Developers may have their hud script toggle these remotely
   //
   //
   //
   // YOU MAY TOUCH THESE
   //
   this.togglesoundfx1 = "ON";// default "ON", change to "OFF" to turn off soundfx1(energy transfer sounds)(1,2)
   this.togglesoundfx2 = "ON";// default "ON", change to "OFF" to turn off soundfx2(countdown timer and alarm)(3,4,5)
   this.togglemessages = "ON";// default "ON", change to "OFF" to turn off messages(all)
   //
   //
   //
   // DO NOT TOUCH THESE PLEASE
   //
   delete missionVariables.secforwardshieldcapacitor;
   delete missionVariables.secaftshieldcapacitor;
   this.secforwardshieldcapacitor = 0.0;
   this.secaftshieldcapacitor = 0.0;
   this.fscpause = 1.0;
   this.ascpause = 1.0;
   this.mySound1 = new SoundSource;
   this.mySound1.sound = "ShieldCapacitorDischarge.ogg";
   this.mySound1.loop = false;
   this.mySound2 = new SoundSource;
   this.mySound2.sound = "ShieldEqualizerEqualizing.ogg";
   this.mySound2.loop = false;
   this.mySound3 = new SoundSource;
   this.mySound3.sound = "ShieldCapacitorCharging.ogg";
   this.mySound3.loop = false;
   this.mySound3.repeatCount = 32;// bugfix v1.1
   this.mySound4 = new SoundSource;
   this.mySound4.sound = "ShieldCapacitorCharging.ogg";
   this.mySound4.loop = false;
   this.mySound4.repeatCount = 32;// bugfix v1.1
   this.mySound5 = new SoundSource;
   this.mySound5.sound = "ShieldCapacitorCharged.ogg";
   this.mySound5.loop = false;
   }

this.playerBoughtEquipment = function(equipmentKey)
   {     
   if(equipmentKey == ("EQ_FORWARD_SHIELD_CAPACITOR_REMOVAL"))
      {
      player.ship.removeEquipment("EQ_FORWARD_SHIELD_CAPACITOR");
      player.ship.removeEquipment("EQ_FORWARD_SHIELD_CAPACITOR_REMOVAL");
      player.credits += 16875;
      }
	  if(equipmentKey == ("EQ_AFT_SHIELD_CAPACITOR_REMOVAL"))
      {
      player.ship.removeEquipment("EQ_AFT_SHIELD_CAPACITOR");
      player.ship.removeEquipment("EQ_AFT_SHIELD_CAPACITOR_REMOVAL");
      player.credits += 16875;
      }
	  if(equipmentKey == ("EQ_SHIELD_EQUALIZER_REMOVAL"))
      {
      player.ship.removeEquipment("EQ_SHIELD_EQUALIZER");
      player.ship.removeEquipment("EQ_SHIELD_EQUALIZER_REMOVAL");
      player.credits += 67500;
      }
   }  

this.equipmentDamaged = this.equipmentDestroyed = function(equipment)
   {  // due to the shield equalizer's high quality cross-connected energy transfer power couplings
      // and robust construction there is more resistance to damage for the SHIELD system in general
      // ALTER DAMAGE CHANCE FOR THE FOLLOWING ITEMS
   if(equipment === "EQ_SHIELD_EQUALIZER")
      {
      if(Math.random() > 0.5)
         {
         player.ship.setEquipmentStatus("EQ_SHIELD_EQUALIZER","EQUIPMENT_OK");
         }
      }
   if(equipment === "EQ_FORWARD_SHIELD_CAPACITOR")
      {
      if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
         {
		 if(Math.random() > 0.5)
		    {
            player.ship.setEquipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR","EQUIPMENT_OK");
            }
		 }
	  else
         {	  
	     if(Math.random() > 0.75)
		    {
			if(this.togglesoundfx1 == "ON")
			   {
               this.mySound1.play();
			   }
            player.ship.forwardShield -= 32.0;
            player.consoleMessage("Forward Shield Capacitor Feedback Damage!!!", 6);
			}
         }
      }
   if(equipment === "EQ_AFT_SHIELD_CAPACITOR")
      {
      if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
         {
		 if(Math.random() > 0.5)
		    {
            player.ship.setEquipmentStatus("EQ_AFT_SHIELD_CAPACITOR","EQUIPMENT_OK");
            }
		 }
	  else
         {	  
	     if(Math.random() > 0.75)
		    {
			if(this.togglesoundfx1 == "ON")
			   {
               this.mySound1.play();
			   }
            player.ship.aftShield -= 32.0;
            player.consoleMessage("Aft Shield Capacitor Feedback Damage!!!", 6);
			}
         }
      }
   if(equipment === "EQ_SHIELD_BOOSTER")
      {
      if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
         {
		 if(Math.random() > 0.65)
		    {
            player.ship.setEquipmentStatus("EQ_SHIELD_BOOSTER","EQUIPMENT_OK");
            }
		 }
      }
   if(equipment === "EQ_NAVAL_SHIELD_BOOSTER")
      {
      if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
         {
		 if(Math.random() > 0.65)
		    {
            player.ship.setEquipmentStatus("EQ_NAVAL_SHIELD_BOOSTER","EQUIPMENT_OK");
            }
		 }
      }
   if(equipment === "EQ_NAVAL_GRID")
      {
      if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
         {
		 if(Math.random() > 0.35)
		    {
            player.ship.setEquipmentStatus("EQ_NAVAL_GRID","EQUIPMENT_OK");
            }
		 }
      }
   }

   
this.shipLaunchedFromStation = function()
   {
   if(this.shieldCheckTimer)
      {
      this.shieldCheckTimer.start();
      }
   else
      {
      this.shieldCheckTimer = new Timer(this, this.shieldCheck,0,0.5);// minimum 0.5 seconds for equalizer to react
      }
   }

this.shieldCheck = function()
   {
   if(player.ship.docked)
      {
      this.secforwardshieldcapacitor = 0.0;// discharge capacitors for safety when docked
      this.secaftshieldcapacitor = 0.0;
      this.shieldCheckTimer.stop();
	  if(this.mySound3.isPlaying)
         {
         this.mySound3.stop();
         }  
      if(this.mySound4.isPlaying)
         {
         this.mySound4.stop();
         }
      }
   else
      { // main script functions
      this.shieldequalizer();
      this.forwardshieldcapacitor();
      this.aftshieldcapacitor();
      }
   }

this.shieldequalizer = function()
   {
   if(player.ship.equipmentStatus("EQ_SHIELD_EQUALIZER") == "EQUIPMENT_OK")
      {
      if(player.ship.forwardShield == player.ship.aftShield)
         {
         return;
         }//----------------------------------------------------UK Eliter bugfix this part just below added
      if((player.ship.forwardShield > player.ship.aftShield) && ((player.ship.forwardShield - player.ship.aftShield) > 2.0))// transfer from forward shield to aft shield
         {
		 if(this.togglesoundfx1 == "ON")
            {
		    this.mySound2.play();
			}
         if((player.ship.forwardShield - player.ship.aftShield) > 50.0)// make transfer smooth
            {
            player.ship.forwardShield -= 25.0;
            player.ship.aftShield += 25.0;
            return;
            }
         if((player.ship.forwardShield - player.ship.aftShield) > 10.0)
            {
            player.ship.forwardShield -= 5.0;
            player.ship.aftShield += 5.0;
            return;
            }
         else
            {
            player.ship.forwardShield -= 1.0;
            player.ship.aftShield += 1.0;
			if((player.ship.forwardShield - player.ship.aftShield) <= 2.0)
			   {
			   player.ship.aftShield = ((player.ship.forwardShield + player.ship.aftShield) / 2);// averaging the shields prevents problems
			   player.ship.forwardShield = player.ship.aftShield;
			   }
            return;
            }
         }//----------------------------------------------------UK Eliter bugfix this part just below added
      if((player.ship.aftShield > player.ship.forwardShield) && ((player.ship.aftShield - player.ship.forwardShield) > 2.0))//transfer from aft shield to forward shield
         {
		 if(this.togglesoundfx1 == "ON")
            {
		    this.mySound2.play();
			}
         if((player.ship.aftShield - player.ship.forwardShield) > 50.0)// make transfer smooth
            {
            player.ship.aftShield -= 25.0;
            player.ship.forwardShield += 25.0;
            return;
            }
         if((player.ship.aftShield - player.ship.forwardShield) > 10.0)
            {
            player.ship.aftShield -= 5.0;
            player.ship.forwardShield += 5.0;
            return;
            }
         else
            {
            player.ship.aftShield -= 1.0;
            player.ship.forwardShield += 1.0;
			if((player.ship.aftShield - player.ship.forwardShield) <= 2.0)
			   {
			   player.ship.forwardShield = ((player.ship.aftShield + player.ship.forwardShield) / 2);// averaging the shields prevents problems
			   player.ship.aftShield = player.ship.forwardShield;
			   }
            return;
            }
         }
      }
   return;
   }

this.forwardshieldcapacitor = function()
   {
   if(player.ship.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") == "EQUIPMENT_OK")
      {
      if(player.ship.forwardShield == player.ship.maxForwardShield)// shield full so charge capacitor
         {
         this.secforwardshieldcapacitor = (this.secforwardshieldcapacitor + (player.ship.forwardShieldRechargeRate * 0.5));
		 if(this.secforwardshieldcapacitor <= 62.5)
		    {
			if(this.togglemessages == "ON")
			   {
			   this.fscpause += 1.0;
			   if(this.fscpause > 3.0)
			      {
			      this.fscpause = 1.0;
			      }
               if(this.fscpause == 2.0)
			      {
				  player.consoleMessage("Forward Shield Capacitor ===> CHARGING...",1.5);
				  }
			   }			
			if(this.togglesoundfx2 == "ON")
               {
			   if(!this.mySound3.isPlaying)
			      {
                  this.mySound3.play();
				  }
               }
			}   			
         if((this.secforwardshieldcapacitor <= 64) && (this.secforwardshieldcapacitor > 62.5))
            {
			if(this.togglemessages == "ON")
			   {
               player.consoleMessage("Forward Shield Capacitor ===> FULLY CHARGED",6);
			   }
			this.secforwardshieldcapacitor = 64; // v1.1 fix
			if(this.mySound3.isPlaying)
               {
               this.mySound3.stop();
               }
			if(this.togglesoundfx2 == "ON")
               {
			   this.mySound5.play();
			   }
            }			
         if(this.secforwardshieldcapacitor > 64)
            {
            this.secforwardshieldcapacitor = 64;
            }
         return;
         }
      if(player.ship.forwardShield < (player.ship.maxForwardShield - (this.secforwardshieldcapacitor + (player.ship.forwardShieldRechargeRate * 0.5))))
         {
		 if(this.mySound3.isPlaying)
            {
            this.mySound3.stop();
            }
         if(this.secforwardshieldcapacitor > 0.0)// shield below capacitor level so discharge capacitor
            {
            player.ship.forwardShield = (player.ship.forwardShield + this.secforwardshieldcapacitor);
            this.secforwardshieldcapacitor = 0.0;
			if(this.togglemessages == "ON")
			   {
               player.consoleMessage("Forward Shield Capacitor DISCHARGED!!!",6);
			   }
			if(this.togglesoundfx1 == "ON")
               {
			   this.mySound1.play();
			   }
            }
         return;
         }
      }
	if(this.mySound3.isPlaying)
      {
      this.mySound3.stop();
      }  
   return;
   }

this.aftshieldcapacitor = function()
   {
   if(player.ship.equipmentStatus("EQ_AFT_SHIELD_CAPACITOR") == "EQUIPMENT_OK")
      {
      if(player.ship.aftShield == player.ship.maxAftShield)// shield full so charge capacitor
         {
         this.secaftshieldcapacitor = (this.secaftshieldcapacitor + (player.ship.aftShieldRechargeRate * 0.5));
		 if(this.secaftshieldcapacitor <= 62.5)
		    {
			if(this.togglemessages == "ON")
			   {
			   this.ascpause += 1.0;
			   if(this.ascpause > 3.0)
			      {
			      this.ascpause = 1.0;
			      }
               if(this.ascpause == 2.0)
			      {
				  player.consoleMessage("Aft Shield Capacitor ===> CHARGING...",1.5);
				  }
			   }			
			if(this.togglesoundfx2 == "ON")
               {
			   if(!this.mySound4.isPlaying)
			      {
                  this.mySound4.play();
				  }
               }
			} 
		 if((this.secaftshieldcapacitor <= 64) && (this.secaftshieldcapacitor > 62.5))
            {
			if(this.togglemessages == "ON")
			   {
               player.consoleMessage("Aft Shield Capacitor ===> FULLY CHARGED",6);
			   }
			this.secaftshieldcapacitor = 64;// v1.1 fix
			if(this.mySound4.isPlaying)
               {
               this.mySound4.stop();
               }
            if(this.togglesoundfx2 == "ON")
               {
			   this.mySound5.play();
			   }
            }
         if(this.secaftshieldcapacitor > 64)
            {
            this.secaftshieldcapacitor = 64;
            }
         return;
         }
      if(player.ship.aftShield < (player.ship.maxAftShield - (this.secaftshieldcapacitor + (player.ship.aftShieldRechargeRate * 0.5))))
         {
		 if(this.mySound4.isPlaying)
            {
            this.mySound4.stop();
            }
         if(this.secaftshieldcapacitor > 0.0)// shield below capacitor level so discharge capacitor
            {
            player.ship.aftShield = (player.ship.aftShield + this.secaftshieldcapacitor);
            this.secaftshieldcapacitor = 0.0;
			if(this.togglemessages == "ON")
			   {
               player.consoleMessage("Aft Shield Capacitor DISCHARGED!!!",6);
			   }
			if(this.togglesoundfx1 == "ON")
               {
			   this.mySound1.play();
			   }
            }
         return;
         }
       }
    if(this.mySound4.isPlaying)
       {
       this.mySound4.stop();
       }
   return;
   }   

this.shipDied = function()
   {
   if(this.shieldCheckTimer)
      {
      this.shieldCheckTimer.stop()
      }
   if(this.mySound3.isPlaying)
      {
      this.mySound3.stop();
      }  
   if(this.mySound4.isPlaying)
      {
      this.mySound4.stop();
      }  
   }	